library STD,IEEE;
use IEEE.std_logic_textio.all;
use STD.textio.all;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
--use IEEE.std_logic_signed.all;
--use IEEE.std_logic_arith.all;

entity FPU_TEST is
end FPU_TEST;

architecture TEST1 of FPU_TEST is
	component FPU
		port(SRC1,SRC2 : in std_logic_vector(31 downto 0);
		     FUNC : in std_logic_vector(3 downto 0);
		     CLK  : in std_logic;
           OUTPUT : out std_logic_vector(31 downto 0));
	end component;
		
	file In_F: text open read_mode is "./in.txt";
	file Out_F: text open write_mode is "./out.txt";
	signal SRC1,SRC2,OUTPUT : std_logic_vector(31 downto 0)
	:= "00000000000000000000000000000000";
	signal CLK : std_logic := '1';
	signal FUNC : std_logic_vector(3 downto 0) := "0000";
begin -- TEST1
	P1: process
		variable Lin,Lout : Line;
		
		variable ReadBufSrc1 : std_logic_vector(31 downto 0)
		--;--read
		--:= "01000000110010000000000000000000";--6.25
		:= "00111111100000000000000000000000";--1
		--:=   "11111111111111111111111111111001";
		--:= "01000000010100000000000000000000";--3.25
		--:= "01000000101010000000000000000000";--5.25
		--:= "01000000101110000000000000000000";--5.75
		--:= "01000001000000000000000000000000";--8
		--:= "01000000101000000000000000000000";--5
		--:= "01000001000100000000000000000000";--9
		--:= "01000001011100000000000000000000";--15
		--:= "01000001110010000000000000000000";--25
		--:= "01000101011111111111000000000000";--4095
		--:= "00000000000000000000000000000000";--0
		--:= "01011111100000000000000000000000";--2^64
		--:= "00111111001000000000000000000000";--0.625
		--:= "00111110110000000000000000000000";--0.375
		variable ReadBufSrc2 : std_logic_vector(31 downto 0)
		--;--read
		:= "00111111100000000000000000000000";--1
		--:= "01000000101010000000000000000000";--5.25
		--:=   "01000000010000000000000000000000";--3
		--:=   "01000001000000000000000000000000";--8
		--:= "01000000000000000000000000000000";--2
		variable ReadBufFunc : std_logic_vector(3 downto 0)
		:= "0001";
		variable ReadBufInt : integer := 0;
		variable WriteBuf : std_logic_vector(31 downto 0);
		variable count : integer := 0;
		variable Clock : std_logic := '0';
		
		--variable comment : string(1 to 2);
		variable comment_src1 : real;
		variable comment_src2 : real;
		variable comment_ans  : real;
	begin -- process P1
	    
--	   -- ↓INVの初期値を求める
--	   Clock := not Clock;
--      CLK <= Clock;
--		SRC1 <= ReadBufSrc1;
--		SRC2 <= ReadBufSrc2;
--		Func <= ReadBufFunc;
--      count := count + 1;
--      wait for 1 ns;
--      
----      --write(Lout,SRC2(31));
----      --write(Lout,' ');
----      --write(Lout,SRC2(30 downto 23));
----      --write(Lout,' ');
----      --write(Lout,SRC1(22 downto 13));
----      write(Lout,SRC2(22 downto 7));
----      write(Lout,' ');
----      write(Lout,' ');
----       
----	   --write(Lout,OUTPUT(31));
----      --write(Lout,' ');
----      --write(Lout,OUTPUT(30 downto 23));
----      --write(Lout,' ');
----      --write(Lout,OUTPUT(22 downto 0));
----      --write(Lout,' ');
----      write(Lout,OUTPUT(22 downto 9));
----      writeline(Out_F,Lout);
--      
--      if (count rem 4) = 1 then
--         write(Lout,'"'); 
--         write(Lout,OUTPUT(22 downto 16));
--         --write(Lout,OUTPUT(22 downto 10));
--         write(Lout,'"');
--         write(Lout,String'(" when M = "));
--         write(Lout,'"');
--         --write(Lout,SRC2(22 downto 9));
--         write(Lout,SRC1(23 downto 16));
--         write(Lout,'"');
--         write(Lout,String'(" else"));
--         writeline(Out_F,Lout);
--         --write(Lout,' ');
--         --writeline(Out_F,Lout);    
--      end if;
--      if ReadBufSrc1 = "01000000011111111100000000000000" then
--	   --if ReadBufSrc2 = "00111111111111111111111000000000" then
--          wait;              -- process termination
--      end if;
--      ReadBufSrc1 := ReadBufSrc1 + "00000000000000000100000000000000";
--	   --ReadBufSrc2 := ReadBufSrc2 + "00000000000000000000000010000000";
--	   --　↑INVの初期値を求める
	   
	    
	   -- ↓ファイル入出力 
	   readline(In_F,Lin);
	   read(Lin,ReadBufSrc1);
	   read(Lin,ReadBufSrc2);
	   --read(Lin,comment);
	   read(Lin,comment_src1);
	   read(Lin,comment_src2);
	   
	   Clock := not Clock;
      CLK <= Clock;
		SRC1 <= ReadBufSrc1;
		SRC2 <= ReadBufSrc2;
		Func <= ReadBufFunc;
      count := count + 1;
      wait for 1 ns;
      WriteBuf := OUTPUT;
      write(Lout,OUTPUT(31));
      write(Lout,' ');
      write(Lout,OUTPUT(30 downto 23));
      write(Lout,' ');
      write(Lout,OUTPUT(22 downto 0));
      write(Lout,' ');
      writeline(Out_F,Lout);
      if (count rem 2) = 0 then                      -- 正負4パターンを4nsで切り替える
         ReadBufSrc1 := ReadBufSrc1 + "10000000000000000000000000000000";
         if (count rem 4) = 0 
         then ReadBufSrc2 := ReadBufSrc2 + "10000000000000000000000000000000";
         end if;
      end if;
      if endfile(In_F) then
          wait;              -- process termination
      end if;
      -- ↑ファイル入出力
      
	end process P1;

	FPU1 : FPU port map (SRC1,SRC2,FUNC,CLK,OUTPUT);

end TEST1;

configuration cnfg_FPU_TEST of FPU_TEST is
	for TEST1
		for FPU1 : FPU use configuration work.FPU1
			port map (SRC1,SRC2,FUNC,CLK,OUTPUT);
		end for;
	end for;
end cnfg_FPU_TEST;
