-- Priority Encoder 3
-- 4bit入力のプライオリティエンコーダ
-- MSBの位置を出力

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Priority3 is

	port(bits       : in std_logic_vector(3 downto 0);
	     Code_out   : out std_logic_vector(1 downto 0));

end Priority3;

architecture STRUCTURE of Priority3 is
begin
   Code_out <= "11" when bits(3) = '1' else
               "10" when bits(2) = '1' else
               "01" when bits(1) = '1' else
               "00";
                        
end STRUCTURE;
